import transcript

#fields = {1:"name", 2:"chrom", 3:"strand", 4:"txStart", 5:"txEnd", 6:"cdsStart", 7:"cdsEnd", 8:"exonCount", 9:"exonStarts", 10:"exonEnds"}

#use ensGene_ref.txt instead of ensGene.txt
fields = {0:"name", 2:"chrom", 3:"strand", 4:"txStart", 5:"txEnd", 6:"cdsStart", 7:"cdsEnd", 8:"exonCount", 9:"exonStarts", 10:"exonEnds", 16:"alias"}

def parse(file):
    txts = []
    
    ff = open(file, 'r')
    
    for line in ff.readlines():
        cols = line.rstrip("\n").split(" ")

        if cols[0]:
            txt = transcript.Transcript(cols[1])
            
            for i in range(len(cols)):
                if i in fields:
                    if i <= 10 or i == 16:
                        setattr(txt, fields[i], cols[i])

            exonStarts = cols[9].rstrip(',').split(',')
            exonEnds = cols[10].rstrip(',').split(',')
            txt.exons = []
            for e in range(len(exonStarts)):
                #start+1: seems necessary at least for mouse ensembl file
                txt.exons.append([int(exonStarts[e])+1, int(exonEnds[e])])

            #calculate transcript length for coverage
            for exon in txt.exons:
                txt.length += int(exon[1]) - int(exon[0]) + 1
            #print txt.name, txt.exonCount, txt.length, txt.exons[0]
            txts.append(txt)
        
    ff.close()
    
    return txts
